'
' MediaMonkey Script
'
' NAME: JustListAlbums 1.8
'
' AUTHOR: trixmoto (http://trixmoto.net)
' DATE : 27/02/2011
'
' INSTALL: Copy to Scripts directory and add the following to Scripts.ini 
'          Don't forget to remove comments (') and set the order appropriately
'
' NOTE: Mask and CompMask variables can include fields... <Artist><Album><Year><Rating><Length><Tot><Max><Discs><Bitrate>
'                                                         <Line><Genre><Comment>
'       TrackMask variable can include: <Track#><Artist><Title><Album><Album Artist><Genre><Year><Bitrate><BPM><Composer>
'                                       <Custom 1><Custom 2><Custom 3><Filename><Length><Rating><Custom 4><Custom 5><Disc#>
'                                       <Comment><Line><Playcount>
'
' [JustListAlbums]
' FileName=JustListAlbums.vbs
' ProcName=JustListAlbums
' Order=1
' DisplayName=Just List Albums
' Description=Just List Albums
' Language=VBScript
' ScriptType=1
'
' FIXES: Added <Genre> and <Comment> fields to Mask and CompMask 
'

Option Explicit

Dim Mask : Mask = "<Artist> - <Album> (<Tot>/<Max>)" 'mask for artist albums
Dim TrackMask : TrackMask = "" 'blank mask means no tracks are displayed
Dim CompMask : CompMask = "<Artist> - <Album> (<Tot>/<Max>)" 'mask for compilation albums
Dim FirstMask : FirstMask = "" 'mask for first track in an album

Sub JustListAlbums 
  Dim list : Set list = SDB.CurrentSongList
  If list.Count = 0 Then
    Call SDB.MessageBox( SDB.Localize("Please select tracks to be exported."), mtError, Array(mbOk))
    Exit Sub
  End If
  
  Dim fso : Set fso = SDB.Tools.FileSystem
  Dim path : path = Script.ScriptPath&".txt"
  Dim fout : Set fout = fso.CreateTextFile(path,True) 
  Dim dic : Set dic = CreateObject("Scripting.Dictionary")
  Dim Progress : Set Progress = SDB.Progress 
  Progress.MaxValue = list.Count
  Progress.Text = SDB.Localize("Exporting...")

  Dim i,itm,iter,str,theyear,rating,length,tot,max,discs,sql,alb,art,comp,itmID,bitrate
  For i = 0 To list.Count-1 
    Set itm = list.Item(i) 
    itmID = itm.Album.ID
    If dic.Exists("#"&itmID) Then
      itmID = 0
    Else
      dic.Item("#"&itmID) = itm.AlbumName
    End If
    
    If itmID > 0 Then
      'calculate field values
      sql = "SELECT Max(CAST(TrackNumber AS INTEGER)) AS vMax, Count(*) AS vTot, Sum(SongLength) AS vLen, Avg(Year/10000) AS vYea, Avg(Rating) AS vRat, Max(CAST(DiscNumber AS INTEGER)) AS vDis, Count(DISTINCT CASE WHEN INSTR(Artist,';')>0 THEN SUBSTR(Artist,1,INSTR(Artist,';')-1) WHEN INSTR(Artist,';')=0 THEN Artist END) AS vArt, Avg(Bitrate) AS vBit FROM Songs WHERE IDAlbum="&itmID
      Set iter = SDB.Database.OpenSQL(sql)
      theyear = getval(iter,"vYea")
      If theyear = "0" Then
        theyear = "????"
      End If
      Dim temp : temp = getval(iter,"vRat")
      If temp < 0 Then 
        rating = "?"
      Else
        temp = temp / 20
        If temp = Int(temp) Then
          rating = temp
        Else
          rating = FormatNumber(temp,1)
        End If
      End If
      length = gettime(getval(iter,"vLen")/1000)
      tot = getval(iter,"vTot")
      max = getval(iter,"vMax")
      art = itm.AlbumArtistName
      alb = itm.AlbumName      
      comp = False
      discs = getval(iter,"vDis")
      If discs = 0 Then
        discs = 1
      End If
      If getval(iter,"vArt") > 1 Then
        comp = True
      End If
      bitrate = getval(iter,"vBit")/1000
   
      'build string from mask
      If comp Then
        If CompMask = "" Then
          str = Mask
        Else
          str = CompMask
        End If
      Else
        str = Mask
      End If
      str = Replace(str,"<Artist>",SDB.toAscii(art))
      str = Replace(str,"<Album>",SDB.toAscii(alb))
      str = Replace(str,"<Year>",theyear)
      str = Replace(str,"<Rating>",rating)
      str = Replace(str,"<Length>",length)
      str = Replace(str,"<Tot>",tot)      
      str = Replace(str,"<Max>",max)
      str = Replace(str,"<Discs>",discs)
      str = Replace(str,"<Bitrate>",bitrate)
      str = Replace(str,"<Line>",VbCrLf)
      If InStr(str,"<Genre>") > 0 Then
        Dim genre : genre = ""
        sql = "SELECT DISTINCT Genres.GenreName FROM Genres,Songs,GenresSongs WHERE GenresSongs.IDSong=Songs.ID AND GenresSongs.IDGenre=Genres.IDGenre AND Songs.IDAlbum="&itmID&" ORDER BY Genres.GenreName"            
        Set iter = SDB.Database.OpenSQL(sql)
        If Not iter.EOF Then
          genre = iter.StringByName("GenreName")
          iter.Next
          While Not iter.EOF
            genre = genre&", "&iter.StringByName("GenreName")
            iter.Next
          WEnd
        End If
        str = Replace(str,"<Genre>",genre)
      End If
      If InStr(str,"<Comment>") > 0 Then
        Dim comment : comment = ""
        sql = "SELECT Comment FROM Albums WHERE ID="&itmID
        Set iter = SDB.Database.OpenSQL(sql)
        If Not iter.EOF Then
          comment = iter.StringByIndex(0)
        End If     
        str = Replace(str,"<Comment>",comment)
      End If
      fout.WriteLine str
      
      'display album tracks
      If Not (TrackMask = "") Then
        str = "AND (Songs.IDAlbum="&itmID&") ORDER BY CAST(Songs.DiscNumber AS INTEGER), CAST(Songs.TrackNumber AS INTEGER)"
        Dim j : j = 0
        Set iter = SDB.Database.QuerySongs(str)
        Do While Not iter.EOF
          j = j + 1
          Call fout.WriteLine(gettrack(iter.Item,j))
          iter.Next
          If Progress.Terminate Then 
            Exit Do
          End If
        Loop 
        Call fout.WriteLine("")
      End If
    End If
    
    Progress.Increase
    SDB.ProcessMessages
    If Progress.Terminate Then 
      Exit For 
    End If 
  Next 

  fout.Close 
  If Not Progress.Terminate Then 
    Dim WShell : Set WShell = CreateObject("WScript.Shell")
    i = WShell.Run(Chr(34)&path&Chr(34),1,0)
  End If 
End Sub 

Function gettime(sec)
  Dim min : min = 0
  sec = Int(sec)
  Do While sec > 59 
    sec = sec - 60
    min = min + 1
  Loop
  If sec < 10 Then
    gettime = min&":0"&sec
  Else
    gettime = min&":"&sec
  End If
End Function

Function getval(iter,nam)
  Dim s : s = iter.StringByName(nam)
  If IsNumeric(s) Then
    getval = s*1
  Else
    getval = 0
  End If
End Function

Function gettrack(itm,i)
  Dim temp,track,title,artist,album,albumartist,genre,theyear
  Dim bitrate,bpm,composer,cust1,cust2,cust3,cust4,cust5,path,length,rating,disc,comment,plays
  
  track = CStr(itm.TrackOrder)
  title = SDB.toAscii(itm.Title)
  artist = SDB.toAscii(itm.ArtistName)
  album = SDB.toAscii(itm.AlbumName)
  albumartist = SDB.toAscii(itm.AlbumArtistName)
  genre = SDB.toAscii(itm.Genre)
  theyear = itm.Year
  bitrate = Int(itm.Bitrate/1000)&"kbps"
  bpm = itm.BPM
  composer = SDB.toAscii(itm.Author)
  cust1 = SDB.toAscii(itm.Custom1)
  cust2 = SDB.toAscii(itm.Custom2)
  cust3 = SDB.toAscii(itm.Custom3) 
  path = SDB.toAscii(itm.Path)
  length = gettime(itm.SongLength/1000)
  temp = itm.Rating
  If temp < 0 Then 
    rating = "?"
  Else
    temp = temp / 20
    If temp = Int(temp) Then
      rating = temp
    Else
      rating = FormatNumber(temp,1)
    End If
  End If  
  theyear = Left(itm.Year,4)
  disc = itm.DiscNumberStr
  track = itm.TrackOrderStr
  cust4 = SDB.toAscii(itm.Custom4)
  cust5 = SDB.toAscii(itm.Custom5)
  Do While Len(track)<2
    track = "0"&track
  Loop  
  If theyear = "0" Then
    theyear = "????"
  End If
  comment = itm.Comment
  plays = itm.PlayCounter
  
  If (i = 1) And Not (FirstMask = "") Then
    gettrack = FirstMask
  Else
    gettrack = TrackMask
  End If
  gettrack = Replace(gettrack,"<Track#>",track)
  gettrack = Replace(gettrack,"<Artist>",artist)
  gettrack = Replace(gettrack,"<Title>",title)
  gettrack = Replace(gettrack,"<Album>",album)
  gettrack = Replace(gettrack,"<Album Artist>",albumartist)
  gettrack = Replace(gettrack,"<Genre>",genre)
  gettrack = Replace(gettrack,"<Year>",theyear)
  gettrack = Replace(gettrack,"<Bitrate>",bitrate)
  gettrack = Replace(gettrack,"<BPM>",bpm)
  gettrack = Replace(gettrack,"<Composer>",composer)
  gettrack = Replace(gettrack,"<Custom 1>",cust1)
  gettrack = Replace(gettrack,"<Custom 2>",cust2)
  gettrack = Replace(gettrack,"<Custom 3>",cust3)  
  gettrack = Replace(gettrack,"<Filename>",path)
  gettrack = Replace(gettrack,"<Length>",length)
  gettrack = Replace(gettrack,"<Rating>",rating)  
  gettrack = Replace(gettrack,"<Custom 4>",cust4)
  gettrack = Replace(gettrack,"<Custom 5>",cust5)    
  gettrack = Replace(gettrack,"<Disc#>",disc)       
  gettrack = Replace(gettrack,"<Comment>",comment)
  gettrack = Replace(gettrack,"<Playcount>",plays)
  gettrack = Replace(gettrack,"<Line>",VbCrLf)
End Function

Sub Install()
  Dim inip : inip = SDB.ApplicationPath&"Scripts\Scripts.ini"
  Dim inif : Set inif = SDB.Tools.IniFileByPath(inip)
  If Not (inif Is Nothing) Then
    inif.StringValue("JustListAlbums","Filename") = "JustListAlbums.vbs"
    inif.StringValue("JustListAlbums","Procname") = "JustListAlbums"
    inif.StringValue("JustListAlbums","Order") = "1"
    inif.StringValue("JustListAlbums","DisplayName") = "Just List Albums"
    inif.StringValue("JustListAlbums","Description") = "Just List Albums"
    inif.StringValue("JustListAlbums","Language") = "VBScript"
    inif.StringValue("JustListAlbums","ScriptType") = "1"
    SDB.RefreshScriptItems
  End If
End Sub